// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : http://services.krediidiinfo.ee/KiCompanyBasic.wsdl
//  >Import : http://services.krediidiinfo.ee/KiCompanyBasic.wsdl:0
// Encoding : UTF-8
// Version  : 1.0
// (07.12.2007 8:53:01 - - $Rev: 7010 $)
// ************************************************************************ //

unit KiCompanyBasicService;

interface

uses InvokeRegistry, SOAPHTTPClient, Types, XSBuiltIns;

const
  IS_OPTN = $0001;


type

  // ************************************************************************ //
  // The following types, referred to in the WSDL document are not being represented
  // in this file. They are either aliases[@] of other types represented or were referred
  // to but never[!] declared in the document. The types from the latter category
  // typically map to predefined/known XML or Borland types; however, they could also 
  // indicate incorrect WSDL documents that failed to declare or import a schema type.
  // ************************************************************************ //
  // !:string          - "http://www.w3.org/2001/XMLSchema"
  // !:integer         - "http://www.w3.org/2001/XMLSchema"
  // !:int             - "http://www.w3.org/2001/XMLSchema"
  // !:boolean         - "http://www.w3.org/2001/XMLSchema"

  CompanyIDData        = class;                 { "http://services.krediidiinfo.ee/KiCompanyBasic.wsdl"[GblCplx] }
  FaultDetailsType     = class;                 { "http://services.krediidiinfo.ee/KiCompanyBasic.wsdl"[Flt][GblCplx] }

  regCode         = WideString;      { "http://services.krediidiinfo.ee/KiCompanyBasic.wsdl"[Smpl] }


  // ************************************************************************ //
  // XML       : CompanyIDData, global, <complexType>
  // Namespace : http://services.krediidiinfo.ee/KiCompanyBasic.wsdl
  // ************************************************************************ //
  CompanyIDData = class(TRemotable)
  private
    FregCode: regCode;
    Fname_: WideString;
  published
    property regCode: regCode     read FregCode write FregCode;
    property name_:   WideString  read Fname_ write Fname_;
  end;

  CompanyIDDataArray = array of CompanyIDData;   { "http://services.krediidiinfo.ee/KiCompanyBasic.wsdl"[GblCplx] }


  // ************************************************************************ //
  // XML       : FaultDetailsType, global, <complexType>
  // Namespace : http://services.krediidiinfo.ee/KiCompanyBasic.wsdl
  // Info      : Fault
  // ************************************************************************ //
  FaultDetailsType = class(ERemotableException)
  private
    Ferrorcode: Int64;
    Ferrorcode_Specified: boolean;
    Fline_no: Int64;
    Fline_no_Specified: boolean;
    procedure Seterrorcode(Index: Integer; const AInt64: Int64);
    function  errorcode_Specified(Index: Integer): boolean;
    procedure Setline_no(Index: Integer; const AInt64: Int64);
    function  line_no_Specified(Index: Integer): boolean;
  published
    property errorcode: Int64  Index (IS_OPTN) read Ferrorcode write Seterrorcode stored errorcode_Specified;
    property line_no:   Int64  Index (IS_OPTN) read Fline_no write Setline_no stored line_no_Specified;
  end;


  // ************************************************************************ //
  // Namespace : http://services.krediidiinfo.ee/KiCompanyBasic.wsdl
  // soapAction: |urn:#FindCompanies|urn:#GetName|urn:#IsRegCodeValid
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : rpc
  // binding   : KiCompanyBasicBinding
  // service   : KiCompanyBasicService
  // port      : KiCompanyBasic
  // URL       : http://services.krediidiinfo.ee/KiCompanyBasic.php
  // ************************************************************************ //
  KiCompanyBasic = interface(IInvokable)
  ['{AD9F3FCB-AE78-7184-82C2-94DACAA1446F}']
    function  findCompanies(const name_: WideString; const count: Integer): CompanyIDDataArray; stdcall;
    function  getName(const regCode: WideString): WideString; stdcall;
    function  isRegCodeValid(const regCode: WideString): Boolean; stdcall;
  end;

function GetKiCompanyBasic(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): KiCompanyBasic;


implementation
  uses SysUtils;

function GetKiCompanyBasic(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): KiCompanyBasic;
const
  defWSDL = 'http://services.krediidiinfo.ee/KiCompanyBasic.wsdl';
  defURL  = 'http://services.krediidiinfo.ee/KiCompanyBasic.php';
  defSvc  = 'KiCompanyBasicService';
  defPrt  = 'KiCompanyBasic';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as KiCompanyBasic);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


procedure FaultDetailsType.Seterrorcode(Index: Integer; const AInt64: Int64);
begin
  Ferrorcode := AInt64;
  Ferrorcode_Specified := True;
end;

function FaultDetailsType.errorcode_Specified(Index: Integer): boolean;
begin
  Result := Ferrorcode_Specified;
end;

procedure FaultDetailsType.Setline_no(Index: Integer; const AInt64: Int64);
begin
  Fline_no := AInt64;
  Fline_no_Specified := True;
end;

function FaultDetailsType.line_no_Specified(Index: Integer): boolean;
begin
  Result := Fline_no_Specified;
end;

initialization
  InvRegistry.RegisterInterface(TypeInfo(KiCompanyBasic), 'http://services.krediidiinfo.ee/KiCompanyBasic.wsdl', 'UTF-8');
  InvRegistry.RegisterAllSOAPActions(TypeInfo(KiCompanyBasic), '|urn:#FindCompanies|urn:#GetName|urn:#IsRegCodeValid');
  InvRegistry.RegisterExternalParamName(TypeInfo(KiCompanyBasic), 'findCompanies', 'name_', 'name');
  InvRegistry.RegisterExternalParamName(TypeInfo(KiCompanyBasic), 'getName', 'name_', 'name');
  RemClassRegistry.RegisterXSInfo(TypeInfo(regCode), 'http://services.krediidiinfo.ee/KiCompanyBasic.wsdl', 'regCode');
  RemClassRegistry.RegisterXSClass(CompanyIDData, 'http://services.krediidiinfo.ee/KiCompanyBasic.wsdl', 'CompanyIDData');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(CompanyIDData), 'name_', 'name');
  RemClassRegistry.RegisterXSInfo(TypeInfo(CompanyIDDataArray), 'http://services.krediidiinfo.ee/KiCompanyBasic.wsdl', 'CompanyIDDataArray');
  RemClassRegistry.RegisterXSClass(FaultDetailsType, 'http://services.krediidiinfo.ee/KiCompanyBasic.wsdl', 'FaultDetailsType');

end.